import "antd/es/form/style";
import _Form from "antd/es/form";
import "antd/es/col/style";
import _Col from "antd/es/col";
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { get, isEqual } from 'lodash-es';
import { useContext, useMemo } from 'react';
import { useStore } from 'zustand';
import { ConfigContext, FormRenderContext } from "../../models/context";
import getRuleList from "../../models/validates";
import { jsx as _jsx } from "react/jsx-runtime";
var valuePropNameMap = {
  Boolean: 'checked'
};
var layoutCol = {
  1: {
    labelCol: {
      span: 5
    },
    wrapperCol: {
      span: 9
    }
  },
  2: {
    labelCol: {
      span: 6
    },
    wrapperCol: {
      span: 14
    }
  },
  3: {
    labelCol: {
      span: 7
    },
    wrapperCol: {
      span: 16
    }
  },
  4: {
    labelCol: {
      span: 7
    },
    wrapperCol: {
      span: 16
    }
  }
};
export default (function (props) {
  var _schema$default;
  var schema = props.schema,
    path = props.path,
    dependValues = props.dependValues,
    tableInline = props.tableInline,
    rootPath = props.rootPath,
    parentHidden = props.parentHidden;
  var configCtx = useContext(ConfigContext);
  var formRenderContext = useContext(FormRenderContext);
  var _useStore = useStore(formRenderContext, function (state) {
      return state === null || state === void 0 ? void 0 : state.context;
    }),
    readOnly = _useStore.readOnly,
    layout = _useStore.layout;
  // globalRules 为全局配置的规则
  var form = configCtx.form,
    widgets = configCtx.widgets,
    globalConfig = configCtx.globalConfig,
    methods = configCtx.methods;
  var type = schema.type,
    title = schema.title,
    list = schema.list,
    valueType = schema.valueType,
    businessType = schema.businessType,
    hidden = schema.hidden;
  var _hidden = parentHidden || hidden;
  if (type === 'Form' && !list) {
    var _Widget = widgets['boxCard'];
    if (_hidden) {
      return /*#__PURE__*/_jsx(_Widget, _objectSpread(_objectSpread({}, props), {}, {
        parentHidden: _hidden
      }));
    }
    return /*#__PURE__*/_jsx(_Col, {
      span: 24,
      style: {
        marginBottom: '24px'
      },
      children: /*#__PURE__*/_jsx(_Widget, _objectSpread({}, props))
    });
  }
  // businessType 当需要做一些特殊的业务处理时使用，比如：在组件渲染之前调用接口获取数据
  // readOnly 为只读状态 直接使用Text
  var mergeReadOnly = readOnly || (schema === null || schema === void 0 ? void 0 : schema.readOnly);
  var textWidget = type === 'Text' ? 'Text' : type === 'Boolean' ? type : 'ReadOnlyText';
  var widgetName = businessType ? businessType : mergeReadOnly ? textWidget : valueType !== null && valueType !== void 0 ? valueType : type;
  var Widget = widgets[widgetName];
  var defaultValue = (_schema$default = schema.default) !== null && _schema$default !== void 0 ? _schema$default : schema.defaultValue;
  var ruleList = getRuleList(schema, form, methods);
  var valuePropName = schema.valuePropName || valuePropNameMap[valueType !== null && valueType !== void 0 ? valueType : type] || undefined;
  var span = (schema === null || schema === void 0 ? void 0 : schema.span) || (globalConfig === null || globalConfig === void 0 ? void 0 : globalConfig.span) || 3;
  if (!Widget) {
    return null;
  }
  var Component = useMemo(function () {
    return function (config) {
      return Widget({
        placeholder: title,
        schema: schema,
        dependValues: dependValues,
        disabled: (config === null || config === void 0 ? void 0 : config.disabled) || (schema === null || schema === void 0 ? void 0 : schema.disabled),
        readOnly: (config === null || config === void 0 ? void 0 : config.readOnly) || mergeReadOnly,
        variant: config !== null && config !== void 0 && config.bordered ? 'outlined' : 'borderless',
        className: config === null || config === void 0 ? void 0 : config.className
      });
    };
  }, [title, JSON.stringify(schema), JSON.stringify(dependValues), tableInline, span, _hidden, widgetName, mergeReadOnly]);
  var allPath = useMemo(function () {
    if (!path) {
      return undefined;
    }
    var _path = path.slice(0, path.length - 1);
    var currentName = path[path.length - 1];
    if (!currentName) {
      return undefined;
    }
    return [].concat(_toConsumableArray(rootPath || []), _toConsumableArray(_path), ['rules', currentName]);
  }, [JSON.stringify(path), JSON.stringify(rootPath)]);
  return /*#__PURE__*/_jsx(_Col, {
    span: _hidden ? 0 : tableInline ? 24 : 24 / span,
    className: schema.type === 'String' && schema.isImport ? 'srender-business-type-import-text' : '',
    children: /*#__PURE__*/_jsx(_Form.Item, {
      noStyle: true,
      shouldUpdate: function shouldUpdate(prevValues, nextValues) {
        if (allPath) {
          return !isEqual(get(prevValues, allPath), get(nextValues, allPath));
        }
        return false;
      },
      children: function children(_ref) {
        var getFieldValue = _ref.getFieldValue;
        var currentRule = allPath ? getFieldValue(allPath) : {};
        var inlineRequired = currentRule === null || currentRule === void 0 ? void 0 : currentRule.required;
        var newRuleList = _toConsumableArray(ruleList || []);
        if (inlineRequired !== null && inlineRequired !== undefined) {
          if (newRuleList !== null && newRuleList !== void 0 && newRuleList.some(function (item) {
            return (item === null || item === void 0 ? void 0 : item.required) !== null && (item === null || item === void 0 ? void 0 : item.required) !== undefined;
          })) {
            newRuleList.forEach(function (item) {
              if ((item === null || item === void 0 ? void 0 : item.required) !== null && (item === null || item === void 0 ? void 0 : item.required) !== undefined) {
                item.required = inlineRequired;
              }
            });
          } else {
            newRuleList.push({
              required: inlineRequired,
              message: "".concat(title, "\u4E3A\u5FC5\u586B\u9879")
            });
          }
        }
        return /*#__PURE__*/_jsx(_Form.Item, {
          label: tableInline ? '' : title,
          labelCol: layout !== 'vertical' ? {
            flex: '0 0 100px'
          } : {},
          colon: !tableInline,
          style: tableInline && {
            marginBottom: 0
          } || {},
          name: path
          // hidden={hidden}
          ,
          noStyle: _hidden,
          initialValue: (valueType !== null && valueType !== void 0 ? valueType : type) === 'Boolean' ? false : defaultValue,
          valuePropName: valuePropName,
          rules: _hidden ? [] : newRuleList,
          className: tableInline && inlineRequired ? 's-render-table-inline-required' : '',
          children: Component(_objectSpread(_objectSpread({}, currentRule), {}, {
            bordered: !tableInline,
            className: tableInline ? 's-render-table-inline-component' : ''
          }))
        });
      }
    })
  });
});