function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import GroupCard from "../../FormRender/widgets/container/GroupCard";
import FieldItem from "../RenderCore/FieldItem";
import FieldList from "../RenderCore/FieldList";
import { filterSchema } from "../utils";
import FileComponent from "../widgets/container/FileComponent";
import { jsx as _jsx } from "react/jsx-runtime";
var renderItem = function renderItem(props) {
  var schema = props.schema,
    rootPath = props.rootPath,
    path = props.path,
    key = props.key,
    tableInline = props.tableInline,
    throttledOnValuesChange = props.throttledOnValuesChange,
    parentHidden = props.parentHidden;
  if (schema.type === 'File') {
    return /*#__PURE__*/_jsx(FileComponent, {
      schema: schema,
      path: path,
      rootPath: rootPath,
      renderCore: RenderCore,
      renderItem: renderItem,
      throttledOnValuesChange: throttledOnValuesChange
    }, key);
  }
  if (schema.type === 'Group') {
    return /*#__PURE__*/_jsx(GroupCard, _objectSpread(_objectSpread({}, props), {}, {
      renderCore: RenderCore
    }));
  }
  if (schema.type === 'Form' && schema !== null && schema !== void 0 && schema.list) {
    return /*#__PURE__*/_jsx(FieldList, {
      schema: schema,
      path: path,
      rootPath: rootPath,
      renderCore: RenderCore,
      renderItem: renderItem,
      throttledOnValuesChange: throttledOnValuesChange
    }, key);
  }
  var child = null;
  if (schema !== null && schema !== void 0 && schema.properties) {
    child = RenderCore({
      schema: schema === null || schema === void 0 ? void 0 : schema.properties,
      parentPath: path,
      rootPath: rootPath,
      parentHidden: schema.hidden
    });
    path = undefined;
  }
  return /*#__PURE__*/_jsx(FieldItem, {
    schema: schema,
    path: path,
    rootPath: rootPath,
    renderCore: RenderCore,
    tableInline: tableInline,
    parentHidden: parentHidden,
    children: child
  }, key);
};
var RenderCore = function RenderCore(props) {
  var schema = props.schema,
    _props$rootPath = props.rootPath,
    rootPath = _props$rootPath === void 0 ? [] : _props$rootPath,
    _props$parentPath = props.parentPath,
    parentPath = _props$parentPath === void 0 ? [] : _props$parentPath,
    throttledOnValuesChange = props.throttledOnValuesChange,
    parentHidden = props.parentHidden;
  var newSchema = filterSchema(schema);
  if (!newSchema || newSchema.length === 0) {
    return null;
  }
  return newSchema.map(function (key) {
    var item = schema[key];
    var path = [].concat(_toConsumableArray(parentPath), [key]);
    return renderItem({
      schema: item,
      path: path,
      key: key,
      rootPath: rootPath,
      throttledOnValuesChange: throttledOnValuesChange,
      parentHidden: parentHidden
    });
  });
};
export default RenderCore;