function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
import "antd/es/config-provider/style";
import _ConfigProvider from "antd/es/config-provider";
var _excluded = ["configProvider", "locale", "widgets", "methods", "form", "validateMessages", "globalProps", "globalConfig", "themeConfig", "request", "isExecutedWatchKeyMapping"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import enUS from 'antd/lib/locale/en_US';
import zhCN from 'antd/lib/locale/zh_CN';
import dayjs from 'dayjs';
import 'dayjs/locale/zh-cn';
import { useEffect, useRef } from 'react';
import { ConfigContext, FormRenderContext } from "../FormRender/models/context";
import { create } from "../FormRender/models/store";
import { widgets as defaultWidgets } from "./widgets";
import "./withProvider.scss";
import { jsx as _jsx } from "react/jsx-runtime";
var withProvider = function withProvider(Element) {
  return function (props) {
    var configProvider = props.configProvider,
      _props$locale = props.locale,
      locale = _props$locale === void 0 ? 'zh-CN' : _props$locale,
      widgets = props.widgets,
      methods = props.methods,
      form = props.form,
      validateMessages = props.validateMessages,
      _props$globalProps = props.globalProps,
      globalProps = _props$globalProps === void 0 ? {} : _props$globalProps,
      _props$globalConfig = props.globalConfig,
      globalConfig = _props$globalConfig === void 0 ? {} : _props$globalConfig,
      _props$themeConfig = props.themeConfig,
      themeConfig = _props$themeConfig === void 0 ? {} : _props$themeConfig,
      request = props.request,
      isExecutedWatchKeyMapping = props.isExecutedWatchKeyMapping,
      otherProps = _objectWithoutProperties(props, _excluded);
    var storeRef = useRef(create());
    var store = storeRef.current;
    useEffect(function () {
      if (locale === 'en-US') {
        dayjs.locale('en');
        return;
      }
      dayjs.locale('zh-cn');
    }, [locale]);

    // 组件卸载
    useEffect(function () {
      return function () {
        form === null || form === void 0 || form.resetFields();
      };
    }, []);
    if (!form) {
      console.warn('Please provide a form instance to FormRender');
      return null;
    }
    var configContext = {
      locale: locale,
      widgets: _objectSpread(_objectSpread({}, defaultWidgets), widgets),
      methods: methods,
      form: form,
      globalProps: globalProps,
      globalConfig: globalConfig,
      request: request,
      themeConfig: themeConfig,
      watch: (otherProps === null || otherProps === void 0 ? void 0 : otherProps.watch) || {},
      isExecutedWatchKeyMapping: isExecutedWatchKeyMapping || {}
    };
    var antdLocale = locale === 'zh-CN' ? zhCN : enUS;
    return /*#__PURE__*/_jsx("div", {
      className: "s-render-box",
      style: themeConfig !== null && themeConfig !== void 0 && themeConfig.colorPrimary ? {
        // @ts-ignore
        '--data-primary': themeConfig.colorPrimary
      } : {},
      children: /*#__PURE__*/_jsx(_ConfigProvider, _objectSpread(_objectSpread({
        theme: {
          token: themeConfig
        }
      }, configProvider), {}, {
        locale: antdLocale,
        form: {
          validateMessages: validateMessages
        },
        children: /*#__PURE__*/_jsx(ConfigContext.Provider, {
          value: configContext,
          children: /*#__PURE__*/_jsx(FormRenderContext.Provider, {
            value: store,
            children: /*#__PURE__*/_jsx(Element, _objectSpread({
              form: form
            }, otherProps))
          })
        })
      }))
    });
  };
};
export default withProvider;